<?php
/**
 * EZHIFU 易支付(www.ezhifu.org) 易支付免签约支付插件
 * 无需签约，快速接入
 */


/**
 * 类
 */
class ezhifu
{
    function __construct()
    {
        $this->ezhifu();
    }

    /**
     * 构造函数
     *
     * @access  public
     * @param
     *
     * @return void
     */
    function ezhifu()
    {

    }

    /**
     * 生成支付代码
     * @param   array   $order      订单信息
     * @param   array   $payment    支付方式信息
     */
    function get_code($order, $payment)
    {
        if (!defined('EC_CHARSET'))
        {
            $charset = 'utf-8';
        }
        else
        {
            $charset = EC_CHARSET;
        }
        //整理参数
		$serverName = $_SERVER['SERVER_NAME'];
		$serverPort = $_SERVER['SERVER_PORT'];
        $url = dirname('http://' . $serverName . ':' . $serverPort . $_SERVER['REQUEST_URI']);
        $url = "?appid={$payment['ezhifu_APPID']}&money={$order['order_amount']}&subject={$order['order_sn']}&logid={$order['log_id']}&returnurl=".urlencode($url . '/respond.php?code=ezhifu');
        $real_method = $payment['ezhifu_pay_method'];
        if(empty($real_method))$real_method = 0;
        $html = "";
        switch ($real_method){
            case '0'://双通道
                $html = '<a class="btn-reset box-flex" href="http://pay.ezhifu.org/'.$url.'&type=1" target="_blank">微信支付</a><a class="btn-reset box-flex" href="http://pay.ezhifu.org/'.$url.'&type=2" target="_blank">支付宝</a>';
                break;
            case '1'://仅微信
                $html = '<a class="btn-reset box-flex" href="http://pay.ezhifu.org/'.$url.'&type=1" target="_blank">微信支付</a>';
                break;
            case '2'://仅支付宝
                $html = '<a class="btn-reset box-flex" href="http://pay.ezhifu.org/'.$url.'&type=2" target="_blank">支付宝付款</a>';
                break;
        }

        return $html;
    }

    /**
     * 响应操作
     */
    function respond()
    {
		include_once BASE_PATH . 'Helpers/payment_helper.php';
        $payment  = get_payment(basename(__FILE__, '.php'));
        unset($_GET['code']);
        $sign = $_GET['sign'];
        unset($_GET['sign']);
        ksort($_GET);
        if(md5(http_build_query($_GET).$payment['ezhifu_APPKEY'])!=$sign){
            return false;
        }
        //校验成功
        $order_sn = $_GET['logid'];
        /* 检查支付的金额是否相符 */
        if (!check_money($order_sn, $_GET['money']))
        {
            return false;
        }
        order_paid($order_sn);
        return true;
    }
    /**
     * 响应操作
     */
    function callback()
    {
		include_once BASE_PATH . 'Helpers/payment_helper.php';
        $payment  = get_payment(basename(__FILE__, '.php'));
        unset($_GET['code']);
        $sign = $_GET['sign'];
        unset($_GET['sign']);
        ksort($_GET);
        if(md5(http_build_query($_GET).$payment['ezhifu_APPKEY'])!=$sign){
            return false;
        }
        //校验成功
        $order_sn = $_GET['logid'];
        /* 检查支付的金额是否相符 */
        if (!check_money($order_sn, $_GET['money']))
        {
            return false;
        }
        order_paid($order_sn);
        return true;
    }
}
?>